////////////////////////////////////////////////////////////////////////////
//   Copyright 2013  Teradici Corporation
//
//   This program is free software; you can redistribute it and/or modify it
//   under the terms and conditions of the GNU General Public License,
//   version 2, as published by the Free Software Foundation.
//
////////////////////////////////////////////////////////////////////////////
/// \file
/// \brief
///     Teradici standard error codes
///
////////////////////////////////////////////////////////////////////////////

#pragma once

// ---- Include Files -------------------------------------------------------

// ---- Constants and Types -------------------------------------------------

// starting base for all error codes
#define TERA_ERR_BASE           -500  ///< base value for Teradici-defined errors

#define TERA_SUCCESS                0                       ///< success
#define TERA_ERR_FAILURE            (TERA_ERR_BASE)         ///< generic failure
#define TERA_ERR_INVALID_ARG        (TERA_ERR_BASE - 1)     ///< invalid input args
#define TERA_ERR_NULL_PTR           (TERA_ERR_BASE - 2)     ///< null pointer
#define TERA_ERR_INVALID_STATE      (TERA_ERR_BASE - 3)     ///< invalid state
#define TERA_ERR_TIMEOUT            (TERA_ERR_BASE - 4)     ///< timeout waiting
#define TERA_ERR_FULL               (TERA_ERR_BASE - 5)     ///< full
#define TERA_ERR_EMPTY              (TERA_ERR_BASE - 6)     ///< empty
#define TERA_ERR_NO_MEMORY          (TERA_ERR_BASE - 7)     ///< no heap memory
#define TERA_ERR_NO_SCRATCH_MEMORY  (TERA_ERR_BASE - 8)     ///< no scratch memory
#define TERA_ERR_INVALID_CTXT       (TERA_ERR_BASE - 9)     ///< invalid context
#define TERA_ERR_NOT_FOUND          (TERA_ERR_BASE - 10)    ///< search not found
#define TERA_ERR_NOT_SUPPORTED      (TERA_ERR_BASE - 11)    ///< feature not supported
#define TERA_ERR_BAD_CRC            (TERA_ERR_BASE - 12)    ///< CRC does not match
#define TERA_ERR_BUSY               (TERA_ERR_BASE - 13)    ///< busy
#define TERA_ERR_ABORT              (TERA_ERR_BASE - 14)    ///< abort
#define TERA_ERR_NOT_AUTHORIZED     (TERA_ERR_BASE - 15)    ///< not authorized
#define TERA_ERR_NOT_READY          (TERA_ERR_BASE - 16)    ///< not ready
#define TERA_ERR_REINIT_NEEDED      (TERA_ERR_BASE - 17)    ///< re-initialization needed
#define TERA_ERR_REVISION_MISMATCH  (TERA_ERR_BASE - 18)    ///< revision mismatch
#define TERA_ERR_IMG_NOT_ACTIVE     (TERA_ERR_BASE - 19)    ///< imaging not active

// ---- Variable Externs ----------------------------------------------------

// ---- Function Prototypes -------------------------------------------------
