////////////////////////////////////////////////////////////////////////////
//   Copyright 2013  Teradici Corporation
//
//   This program is free software; you can redistribute it and/or modify it
//   under the terms and conditions of the GNU General Public License,
//   version 2, as published by the Free Software Foundation.
//
////////////////////////////////////////////////////////////////////////////
/// \file
/// \brief
///     Memory Allocation and Operation Macros
///
///     This file defines macros that simplify memory allocations and
///     operations.
///
////////////////////////////////////////////////////////////////////////////

#pragma once

// ---- Include Files -------------------------------------------------------
#include <stdlib.h>
#include <string.h>

// ---- Constants and Types -------------------------------------------------

#define mTERA_MEM_ALLOC(len)           malloc(len);
#define mTERA_MEM_CALLOC(len)          calloc(1, len);
#define mTERA_MEM_FREE(ptr)            free(ptr); ptr = NULL;
#define mTERA_MEM_ZERO(ptr, len)       memset(ptr, 0, len);
#define mTERA_MEM_COPY(dst, src, len)  memcpy(dst, src, len);

// ---- Variable Externs ----------------------------------------------------

// ---- Function Prototypes -------------------------------------------------

