////////////////////////////////////////////////////////////////////////////
//   Copyright 2013  Teradici Corporation
//
//   This program is free software; you can redistribute it and/or modify it
//   under the terms and conditions of the GNU General Public License,
//   version 2, as published by the Free Software Foundation.
//
////////////////////////////////////////////////////////////////////////////
/// \file
/// \brief
///     PCoIP Host Software Property Sheet Class
///
///     This file defines the PCoIP Host Software property sheet class.
///
////////////////////////////////////////////////////////////////////////////

#pragma once

// ---- Include Files -------------------------------------------------------

#include <wx/propdlg.h>
#include <wx/generic/propdlg.h>
#include <wx/toolbook.h>
#include <wx/panel.h>
#include "tera_pcoip_agent_gui_prop_feat.h"
#include "tera_pcoip_agent_gui_prop_net.h"
#include "tera_pcoip_agent_gui_prop_stat.h"
#include "tera_pcoip_agent_gui_prop_mon.h"
#include "tera_pcoip_agent_gui_prop_img.h"
#include "tera_pcoip_agent_gui_prop_about.h"

// ---- Constants and Types -------------------------------------------------

// --------------------------------------------------------------------------
//  cPCOIP_AGENT_GUI_PROP
///     PCoIP Host Software property sheet
//
//  Description:
///     This class implements the PCoIP Host Software property sheet. The property
///     sheet is the container for the property pages.
///
class cPCOIP_AGENT_GUI_PROP : public wxPropertySheetDialog
{

public:

    // --- Public Functions -------------------------------------------------

    cPCOIP_AGENT_GUI_PROP(
        wxWindow *parent);

    ~cPCOIP_AGENT_GUI_PROP(void);

    // --- Public Variables -------------------------------------------------

    cPCOIP_AGENT_GUI_PROP_FEAT    *m_feat_page;
    cPCOIP_AGENT_GUI_PROP_STAT    *m_stat_page;
    cPCOIP_AGENT_GUI_PROP_MON     *m_mon_page;

protected:

    // --- Protected Functions ----------------------------------------------

    void evt_init_dialog(
        wxInitDialogEvent& evt);

    void evt_close(
        wxCloseEvent& evt);

    // --- Protected Variables ----------------------------------------------

    cPCOIP_AGENT_GUI_PROP_NET     *m_net_page;
    cPCOIP_AGENT_GUI_PROP_IMG     *m_img_page;
    cPCOIP_AGENT_GUI_PROP_ABOUT   *m_about_page;

    DECLARE_EVENT_TABLE()
}; // cPCOIP_AGENT_GUI_PROP

// ---- Variable Externs ----------------------------------------------------

// ---- Function Prototypes -------------------------------------------------

